代码随想录算法训练营Day 2 | 数组(2/2) Leetcode 977.有序数组的平方 209.长度最小的子数组 59.螺旋矩阵II

今天继续学习

第一题 

977. Squares of a Sorted Array

Given an integer array nums sorted in non-decreasing order, return an array of the squares of each number sorted in non-decreasing order.

看到题干以后,首先想到的就是Brute force,用for循环挨个平方一遍,最后nums.sort()排序就完事。用时2分11秒。

# Brute force
class Solution:
    def sortedSquares(self, nums: List[int]) -> List[int]:
        for i in range(len(nums)):
            nums[i] = nums[i] * nums[i]
            i += 1
        nums.sort()
        return nums

但是光排序就O(nlogn),费劲,而且这么解题没有意义,起不到任何练习算法的作用。

感觉解题的关键点应该在双指针,但是思路被局限到平方→排序的过程中了,应用双指针应该也是在平方完之后进行排序吧?

重新修改一下思路,先别急着算平方数,可以利用双指针和一个新的数组来做,最后return新数组就可以了。

而且这是一个non-decreasing数组,平方以后最大的数正好是头和尾这两个数。

这道题的基本思路就是这样子了。用时6分25秒实现。

class Solution:
    def sortedSquares(self, nums: List[int]) -> List[int]:
        newList = [0] * len(nums)
        l, r = 0, len(nums)-1
        n = len(nums)-1
        while l <= r:
            if nums[l] **2 < nums[r] ** 2:
                newList[n] = nums[r] **2
                r -= 1
            else:
                newList[n] = nums[l] **2
                l += 1
            n -= 1
        return newList

第二题

209. Minimum Size Subarray Sum

Given an array of positive integers nums and a positive integer target, return the minimal length of a subarray whose sum is greater than or equal to target. If there is no such subarray, return 0 instead.

两个for循环的brute force复杂度到了O(n^2),显然不是最好的解决办法,这应该用滑动窗口的思路去解。

但是coding不出来。

愁。

优化解法:滑动窗口
在本题中实现滑动窗口,主要确定如下三点:

  • 窗口内是什么?
  • 如何移动窗口的起始位置?
  • 如何移动窗口的结束位置?
  1. 窗口就是 满足其和 ≥ s 的长度最小的 连续 子数组。
  2. 窗口的起始位置如何移动:如果当前窗口的值大于s了,窗口就要向前移动了(也就是该缩小了)。
  3. 窗口的结束位置如何移动:窗口的结束位置就是遍历数组的指针,也就是for循环里的索引。

解题的关键在于 窗口的起始位置如何移动。

代码参考了别人的解法: 

class Solution:
    def minSubArrayLen(self, target: int, nums: List[int]) -> int:
        res = float("inf")
        i = 0 # window start
        sum = 0 # window length
        for j in range(len(nums)):
            sum += nums[j]
            while sum >= target:
                res = min(res,j-i+1)
                sum -= nums[i]
                i += 1
        return 0 if res == float("inf") else res

整道题最精彩的地方就在于while里面对于窗口大小的调整。

拿一个无穷大来比较,最后还是无穷大的话就输出0也是一个聪明的办法

第三题

59. Spiral Matrix II

Given a positive integer n, generate an n x n matrix filled with elements from 1 to n2 in spiral order.

应该先找找规律,n是奇数的时候,最大数应该在最中间。n是偶数的话,那只能左→下→右→上的顺序填,并且每次要更新填数的起点。

不会做。看看别人的解法:

class Solution:
    def generateMatrix(self, n: int) -> List[List[int]]:
        matrix = [[0 for _ in range(n)] for _ in range(n)]
        i, r, c = 1, 0, 0

        while i <= n**2:
            while r < n and matrix[c][r] == 0:
                matrix[c][r] = i
                r += 1 if r != n-1 and matrix[c][r+1] == 0 else 0
                i += 1
            c += 1

            while c < n and matrix[c][r] == 0:
                matrix[c][r] = i
                c += 1 if c != n-1 and matrix[c+1][r] == 0 else 0
                i += 1
            r -= 1

            while r >= 0 and matrix[c][r] == 0:
                matrix[c][r] = i
                r -= 1 if r != 0 and matrix[c][r-1] == 0 else 0
                i += 1
            c -= 1

            while c >= 0 and matrix[c][r] == 0:
                matrix[c][r] = i
                c -= 1 if c != 0 and matrix[c-1][r] == 0 else 0
                i += 1
            r += 1

        return matrix

你可能感兴趣的:(LeetCode,leetcode)